// FilmGrain.fx
//
// Copyright Outerspace Software, all rights reserved

string description = "Film Grain Filter Effect. This effect makes your texture look as if it's seen through frosted glass.";

float4x4	WorldViewProjection;
float4		DiffuseCol;

float4 Prop0
<
string UIName="Size";
float UIMin=0;
float UIMax=10;
float3 UIDefault=float3(1,0,0);
int UISliders=1;
float UIScale=1;
bool UIInteger=false;
int UIWidget=0;
> = float4(1,0,0,0);

texture MyTexture0;
sampler MyTextureSampler0 = sampler_state{
    Texture   = (MyTexture0);
    AddressU  = CLAMP;
    AddressV  = CLAMP;
    MipFilter = LINEAR;
    MinFilter = LINEAR;
    MagFilter = LINEAR;
};

struct VS_INPUT{
	float4 position:	POSITION;
	float3 normal:		NORMAL;
	float3 diffuse:		COLOR;
	float2 tex:		TEXCOORD0;
};

struct VS_OUTPUT{
	float4 position:	POSITION;
	float2 tex:		TEXCOORD0;
};

struct PS_OUTPUT{
    float4 color:		COLOR;
};

VS_OUTPUT VS(VS_INPUT input){
	VS_OUTPUT output;		
	output.position = mul(input.position,WorldViewProjection);
	output.tex = input.tex;	
	return output;
}

PS_OUTPUT PS(VS_OUTPUT input){
	PS_OUTPUT output;

	float dirty=Prop0.x;
	
	float2 t = input.tex;		
	float x=t.x*t.y*123456;
	x=fmod(x,13) * fmod(x,123);	
	
	float dx = -0.005+fmod(x,0.01);
	float dy = -0.006+fmod(x,0.012);
	float4 c=tex2D(MyTextureSampler0, t+dirty*float2(dx,dy));		
		
	output.color = DiffuseCol*c;    
	return output;
}

technique pixels{
    pass p0
    {   
	VertexShader = compile vs_2_0 VS();
	PixelShader  = compile ps_2_0 PS();
    }
}

